﻿local G, F, C, L = unpack(select(2,...))
local function TestFunc()
if AddUIDB.quest ==  false  then return end

--任务
ObjectiveTrackerFrame:SetScale(.9)--任务大小

--固定任务缩放框体
local rw = ObjectiveTrackerFrame.HeaderMenu.MinimizeButton
rw:ClearAllPoints()
rw:SetPoint("bottomright", Minimap, "bottomright", 10,-15)
rw:SetScale(1.2)

local vm = ObjectiveTrackerFrame

--[[移动任务栏
    local vmheight = 360			--任务栏高度
    local vmwidth = 250				--任务栏宽度
    
	--移动框体
    vm:SetClampedToScreen(true)
    vm:ClearAllPoints()
    vm.ClearAllPoints = function() end 
	vm:SetPoint("TOPRIGHT", MinimapCluster, "BOTTOM", 45, -5) 
    vm.SetPoint = function() end
    vm:SetMovable(true)
    vm:SetUserPlaced(true)
    vm:SetHeight(vmheight)
    vm:SetWidth(vmwidth)
	
    local vmmove = CreateFrame("FRAME", nil, vm)  
    vmmove:SetHeight(16)
    vmmove:SetPoint("TOPLEFT", vm, 0, 0)
    vmmove:SetPoint("TOPRIGHT", vm)
    vmmove:EnableMouse(true)
    vmmove:RegisterForDrag("LeftButton")
    vmmove:SetHitRectInsets(-5, -5, -5, -5)
       vmmove:SetScript("OnDragStart", function(self, button)
    	if IsModifiedClick() and button=="LeftButton" then
        	local f = self:GetParent()
        	f:StartMoving()
        end
    end)
    
    vmmove:SetScript("OnDragStop", function(self, button)
        local f = self:GetParent()
        f:StopMovingOrSizing()
    end)
--]]
--vm:SetPoint("TOPRIGHT", MinimapCluster, "BOTTOM", 45, -5) 

	-- 任务物品放左面 -------------------------------------------------------------------
    local function moveQuestObjectiveItems(self)
	    local a = {self:GetPoint()}
	        
	    self:ClearAllPoints()
		self:SetPoint("TOPLEFT", a[2], "TOPLEFT", -40, 2)
		self:SetScale(1.2)
		self:SetFrameLevel(0)
	end
	
	local qitime = 0
	local qiinterval = 1
	
    hooksecurefunc("QuestObjectiveItem_OnUpdate", function(self, elapsed)
    	qitime = qitime + elapsed
    	
    	--if qitime > qiinterval then
        	moveQuestObjectiveItems(self)
        	qitime = 0
        --end
    end)
--]]

-- 标题样式 -------------------------------------------------------
    if IsAddOnLoaded("Blizzard_ObjectiveTracker") then
        hooksecurefunc("ObjectiveTracker_Update", function(reason, id)
            if vm.MODULES then  
                for i = 1, #vm.MODULES do                               
		            vm.MODULES[i].Header.Background:SetAtlas(nil)
		            vm.MODULES[i].Header.Text:SetFont(STANDARD_TEXT_FONT, 16,"OUTLINE")
		            vm.MODULES[i].Header.Text:ClearAllPoints()
		            vm.MODULES[i].Header.Text:SetPoint("Left", vm.MODULES[i].Header, 60, 0)
		            vm.MODULES[i].Header.Text:SetJustifyH("Left")
	            end
	        end
	    end)
	end
     
--------------------------------------------------------------------------------------------------------
--                                    显示任务等级                                      --
--------------------------------------------------------------------------------------------------------
local QuestLevelPatch = {}

-- 追踪栏显示任务等级
function SetBlockHeader_hook()
	for i = 1, GetNumQuestWatches() do
		local questID, title, questLogIndex, numObjectives, requiredMoney, isComplete, startEvent, isAutoComplete, failureTime, timeElapsed, questType, isTask, isStory, isOnMap, hasLocalPOI = GetQuestWatchInfo(i)
		if ( not questID ) then
			break
		end
		local oldBlock = QUEST_TRACKER_MODULE:GetExistingBlock(questID)
		if oldBlock then
			local oldHeight = QUEST_TRACKER_MODULE:SetStringText(oldBlock.HeaderText, title, nil, OBJECTIVE_TRACKER_COLOR["Header"])
			local newTitle = "["..select(2, GetQuestLogTitle(questLogIndex)).."] "..title
			local newHeight = QUEST_TRACKER_MODULE:SetStringText(oldBlock.HeaderText, newTitle, nil, OBJECTIVE_TRACKER_COLOR["Header"])

		end
	end
end
hooksecurefunc(QUEST_TRACKER_MODULE, "Update", SetBlockHeader_hook)

-- 任务详细信息显示任务等级
function QuestInfo_hook(template, parentFrame, acceptButton, material, mapView)
	local elementsTable = template.elements
	for i = 1, #elementsTable, 3 do
		if elementsTable[i] == QuestInfo_ShowTitle then
			if QuestInfoFrame.questLog then
				local questLogIndex = GetQuestLogSelection()
				local level = select(2, GetQuestLogTitle(questLogIndex))
				local newTitle = "["..level.."] "..QuestInfoTitleHeader:GetText()
				QuestInfoTitleHeader:SetText(newTitle)
			end
		end
	end
end
hooksecurefunc("QuestInfo_Display", QuestInfo_hook)


-- 任务追踪自动开启/关闭 --------------------------------------------
--ObjectiveTracker_Collapse()--任务关闭
    local vmboss = CreateFrame("Frame", nil)
    vmboss:RegisterEvent("PLAYER_ENTERING_WORLD")
    vmboss:RegisterEvent("INSTANCE_ENCOUNTER_ENGAGE_UNIT")
    vmboss:RegisterEvent("UNIT_TARGETABLE_CHANGED")
    vmboss:RegisterEvent("PLAYER_REGEN_ENABLED")
    --vmboss:RegisterEvent("UPDATE_WORLD_STATES")

    local function bossexists()
	    for i = 1, MAX_BOSS_FRAMES do
		    if UnitExists("boss"..i) then
			    return true
		    end
	    end
    end

    vmboss:SetScript("OnEvent", function(self, event)
        local _, instanceType = IsInInstance()
        local bar = _G["WorldStateCaptureBar1"]
        
       -- 团本boss战自动关闭
	    if instanceType=="raid" and bossexists() then
		    if not vm.collapsed then
			    ObjectiveTracker_Collapse()
		    end

		-- PVP自动关闭
	    elseif instanceType=="arena" or instanceType=="pvp" then
            if not vm.collapsed then
			    ObjectiveTracker_Collapse()
		    end
		-- 获得追踪栏关闭
		elseif bar and bar:IsVisible() then
		    if not vm.collapsed then
			    ObjectiveTracker_Collapse()
		    end
		-- 团队副本且不在战斗状态打开
	    elseif vm.collapsed and instanceType=="raid" and not InCombatLockdown() then
		    ObjectiveTracker_Expand()
		
	    end

    end)
	
end
G:RegisterEvent("PLAYER_LOGIN",TestFunc)