local G, F, C, L = unpack(select(2,...))
local function TestFunc()
if AddUIDB.unitf ==  false  then return end

------------------------------------------------
-- 修改默认头像
------------------------------------------------
-- 目标连击点大小
ComboFrame:SetScale(1.1)

-- 玩家与目标框架大小
TargetFrame:SetScale(1.2)
PlayerFrame:SetScale(1.2)

--SetCVar("threatShowNumeric", 0) 									--目标头像显示仇恨

--目标仇恨位置
TargetFrameNumericalThreat:ClearAllPoints()
TargetFrameNumericalThreat:SetPoint("TOP", TargetFrame, "TOP",40,0)


-------------------------------------
-- 目標框架: 顯示debuff倒計時
-------------------------------------

hooksecurefunc("TargetFrame_UpdateAuras", function(self)
    local selfName = self:GetName()
    local maxDebuffs = self.maxDebuffs or MAX_TARGET_DEBUFFS
    local _, frame, debuffName, duration
	for i = 1, maxDebuffs do
        frame = _G[selfName.."Debuff"..i.."Cooldown"]
        if (frame) then
            debuffName, _, _, _, duration = UnitDebuff(self.unit, i, "PLAYER")	--只顯示自己PLAYER, 全部顯示 INCLUDE_NAME_PLATE_ONLY
            if (debuffName and duration and duration <= 60) then
                frame:SetHideCountdownNumbers(false)
            else
                frame:SetHideCountdownNumbers(true)
            end
        end
    end
end)


--显示目标可驱散buff高亮--
hooksecurefunc("TargetFrame_UpdateAuras", function(self)
local frame, frameName
local selfName = self:GetName()
local name, icon, count, debuffType, duration, expirationTime, caster, isStealable
local frameStealable
local playerIsTarget = UnitIsUnit(PlayerFrame.unit, self.unit)
local _, class = UnitClass("player")

for index = 1, MAX_TARGET_BUFFS do
name, icon, count, debuffType, duration, expirationTime, caster, canStealOrPurge = UnitBuff(self.unit, index, filter)
frameName = selfName.."Buff"..index
frame = _G[frameName]

if (frame and frame:IsShown()) then
frameStealable = _G[frameName.."Stealable"]
if ( not playerIsTarget and debuffType == "Magic" ) then
frameStealable:Show()
else
frameStealable:Hide()
end
end
end
end)

--头像材质
function UnitFramesImproved_Style_PlayerFrame()
    if not UnitHasVehicleUI("player") then
        PlayerName:SetPoint("CENTER", 50, 35)
        PlayerFrameHealthBar:ClearAllPoints()
        PlayerFrameHealthBar:SetPoint("TOPLEFT", 107, -24)
        PlayerFrameHealthBar:SetHeight(29)
        PlayerFrameHealthBarText:ClearAllPoints()
		PlayerFrameHealthBarText:SetPoint("CENTER", PlayerFrameHealthBar, "CENTER", 0, 0)				
		PlayerFrameHealthBarTextLeft:ClearAllPoints()
		PlayerFrameHealthBarTextLeft:SetPoint("LEFT", PlayerFrameHealthBar, "LEFT", 3, 0)
		PlayerFrameHealthBarTextRight:ClearAllPoints()
		PlayerFrameHealthBarTextRight:SetPoint("RIGHT", PlayerFrameHealthBar, "RIGHT", -3, 0) 
	else
        PlayerFrameHealthBar:SetHeight(12)
    end	
	PlayerFrameTexture:SetTexture("Interface\\Addons\\AddUI\\UI\\Textures\\UI-TargetingFrame");
	PlayerStatusTexture:SetTexture("Interface\\Addons\\AddUI\\UI\\Textures\\UI-Player-Status");
end


function UnitFramesImproved_Style_TargetFrame(self)
    self.nameBackground:Hide();
    self.healthbar:SetHeight(29);
	self.healthbar:SetPoint("TOPLEFT", 5, -24)
	self.Background:SetPoint("TOPLEFT",7,-22)
	self.name:SetPoint("CENTER", -50, 35)
    self.deadText:SetPoint("CENTER", self.healthbar, "CENTER", 0, 0)	
    self.healthbar.TextString:ClearAllPoints()
	self.healthbar.TextString:SetPoint("CENTER", self.healthbar, "CENTER", 0, 0)		
	self.healthbar.LeftText:ClearAllPoints()
    self.healthbar.LeftText:SetPoint("LEFT", self.healthbar, "LEFT", 3, 0)
	self.healthbar.RightText:ClearAllPoints()
	self.healthbar.RightText:SetPoint("RIGHT", self.healthbar, "RIGHT", -3, 0)   	
end

function UnitFramesImproved_Style_TargetOfTargetFrame()
    -- TargetOfTarget
	TargetFrameToTBackground:SetPoint("TOPLEFT",46,-13)
    TargetFrameToTHealthBar:ClearAllPoints()
    TargetFrameToTHealthBar:SetPoint("TOPLEFT", 44, -15)
    TargetFrameToTHealthBar:SetHeight(10)
	TargetFrameToTManaBar:ClearAllPoints()
	TargetFrameToTManaBar:SetPoint("TOPLEFT", 44, -25)	
	TargetFrameToTManaBar:SetHeight(4)
    -- TargetOfFocus
	FocusFrameToTBackground:SetPoint("TOPLEFT",46,-13)
    FocusFrameToTHealthBar:ClearAllPoints()
    FocusFrameToTHealthBar:SetPoint("TOPLEFT", 44, -15)
    FocusFrameToTHealthBar:SetHeight(10)
	FocusFrameToTManaBar:ClearAllPoints()
	FocusFrameToTManaBar:SetPoint("TOPLEFT", 44, -25)	
    FocusFrameToTManaBar:SetHeight(4)	
end

function UnitFramesImproved_BossTargetFrame_Style(self)
	UnitFramesImproved_Style_TargetFrame(self);
end

function UnitFramesImproved_TargetFrame_CheckClassification(self)	
	self.nameBackground:Hide();
end

function UnitFramesImproved_TargetFrame_CheckFaction(self)
	UnitFramesImproved_Style_TargetFrame(self);
end

function EnableUnitFramesImproved()
	-- BossFrame hooks
	hooksecurefunc("BossTargetFrame_OnLoad", UnitFramesImproved_BossTargetFrame_Style);
	
	-- PlayerFrame
	hooksecurefunc("PlayerFrame_UpdateArt", UnitFramesImproved_Style_PlayerFrame)
    hooksecurefunc("PlayerFrame_SequenceFinished", UnitFramesImproved_Style_PlayerFrame)
	
	-- TargetFrame
	hooksecurefunc("TargetFrame_CheckFaction", UnitFramesImproved_TargetFrame_CheckFaction);
	hooksecurefunc("TargetFrame_CheckClassification", UnitFramesImproved_TargetFrame_CheckClassification);    
		
	-- Set up some stylings
	UnitFramesImproved_Style_PlayerFrame();
	UnitFramesImproved_Style_TargetFrame(TargetFrame);
	UnitFramesImproved_Style_TargetFrame(FocusFrame);
	UnitFramesImproved_Style_TargetOfTargetFrame();
	
	UnitFramesImproved_BossTargetFrame_Style(Boss1TargetFrame);
	UnitFramesImproved_BossTargetFrame_Style(Boss2TargetFrame);
	UnitFramesImproved_BossTargetFrame_Style(Boss3TargetFrame);
	UnitFramesImproved_BossTargetFrame_Style(Boss4TargetFrame);
	UnitFramesImproved_BossTargetFrame_Style(Boss5TargetFrame);
	
end

local UnitFramesImproved = CreateFrame('Frame', 'UnitFramesImproved')

UnitFramesImproved:SetScript('OnEvent', function(self, event, ...) 
	EnableUnitFramesImproved()  
end);
UnitFramesImproved:RegisterEvent('PLAYER_ENTERING_WORLD');
UnitFramesImproved:RegisterEvent('VARIABLES_LOADED');
UnitFramesImproved:RegisterEvent('ZONE_CHANGED_NEW_AREA');

---------------------------------------------------
-- 隐藏头像伤害数字
--------------------------------------------------
PlayerHitIndicator:SetText(nil)
PlayerHitIndicator.SetText = function() end
PetHitIndicator:SetText(nil)
PetHitIndicator.SetText = function() end
PetName:Hide()

--隐藏宠物生命值显示
PetFrameHealthBar.cvar = nil; 
PetFrameManaBar.cvar = nil; 
		
---------------------------------------------------
-- 职业染色
---------------------------------------------------
local color = true
local function colors(self, unit)
    if unit and unit == self.unit then	
        if UnitIsPlayer(unit) then
		    local _, class = UnitClass(unit)
            color = CUSTOM_CLASS_COLORS and CUSTOM_CLASS_COLORS[class] or RAID_CLASS_COLORS[class]
        elseif UnitReaction(unit, "player") then
            color = FACTION_BAR_COLORS and FACTION_BAR_COLORS[UnitReaction(unit, "player")]
		end
        if (not UnitIsConnected(unit)) then	
		    self:SetStatusBarColor(0.5, 0.5, 0.5)
		else	
		    if color then             
			    self:SetStatusBarColor(color.r, color.g, color.b)
			end
        end
	end		
end

hooksecurefunc("UnitFrameHealthBar_Update", colors)
hooksecurefunc("HealthBar_OnValueChanged", function(self)
    colors(self, self.unit)
end)

---BOSS框架材质
function UnitFramesImproved_BossTargetFrame_Style(self)
	self.borderTexture:SetTexture("Interface\\Addons\\AddUI\\UI\\Textures\\UI-UnitFrame-Boss");
	UnitFramesImproved_Style_TargetFrame(self);
end
hooksecurefunc("BossTargetFrame_OnLoad", UnitFramesImproved_BossTargetFrame_Style);

--目标框架
function UnitFramesImproved_TargetFrame_CheckClassification(self, forceNormalTexture)
	local texture;
	local classification = UnitClassification(self.unit);
	if ( classification == "worldboss" or classification == "elite" ) then
		texture = "Interface\\Addons\\AddUI\\UI\\Textures\\UI-TargetingFrame-Elite";
	elseif ( classification == "rareelite" ) then
		texture = "Interface\\Addons\\AddUI\\UI\\Textures\\UI-TargetingFrame-Rare-Elite";
	elseif ( classification == "rare" ) then
		texture = "Interface\\Addons\\AddUI\\UI\\Textures\\UI-TargetingFrame-Rare";
	end
	if ( texture and not forceNormalTexture) then
		self.borderTexture:SetTexture(texture);
	else
		if ( not (classification == "minus") ) then
			self.borderTexture:SetTexture("Interface\\Addons\\AddUI\\UI\\Textures\\UI-TargetingFrame");
		end
	end
	
	self.nameBackground:Hide();
end
hooksecurefunc("TargetFrame_CheckClassification", UnitFramesImproved_TargetFrame_CheckClassification);

--开始染黑边	
local CF=CreateFrame("Frame")
CF:RegisterEvent("PLAYER_ENTERING_WORLD")
CF:SetScript("OnEvent", function(self, event)
	if not (IsAddOnLoaded("Shadowed Unit Frames") or IsAddOnLoaded("PitBull Unit Frames 4.0") or IsAddOnLoaded("X-Perl UnitFrames")) then
               	for i,v in pairs({
			PlayerFrameTexture,
   			TargetFrameTextureFrameTexture,
  			PetFrameTexture,
			PartyMemberFrame1Texture,
			PartyMemberFrame2Texture,
			PartyMemberFrame3Texture,
			PartyMemberFrame4Texture,
			PartyMemberFrame1PetFrameTexture,
			PartyMemberFrame2PetFrameTexture,
			PartyMemberFrame3PetFrameTexture,
			PartyMemberFrame4PetFrameTexture,
			FocusFrameTextureFrameTexture,
			TargetFrameToTTextureFrameTexture,
			FocusFrameToTTextureFrameTexture,
			Boss1TargetFrameTextureFrameTexture,
			Boss2TargetFrameTextureFrameTexture,
			Boss3TargetFrameTextureFrameTexture,
			Boss4TargetFrameTextureFrameTexture,
			Boss5TargetFrameTextureFrameTexture,
			Boss1TargetFrameSpellBarBorder,
			Boss2TargetFrameSpellBarBorder,
			Boss3TargetFrameSpellBarBorder,
			Boss4TargetFrameSpellBarBorder,
			Boss5TargetFrameSpellBarBorder,
			CastingBarFrameBorder,
			FocusFrameSpellBarBorder,
			TargetFrameSpellBarBorder,
		}) do
          		v:SetVertexColor(.3, .3, .3)
		end
		for i,v in pairs({
			PlayerPVPIcon,
			TargetFrameTextureFramePVPIcon,
			FocusFrameTextureFramePVPIcon,
		}) do
			v:SetAlpha(0)
		end
		for i=1,4 do 
			_G["PartyMemberFrame"..i.."PVPIcon"]:SetAlpha(0)
			_G["PartyMemberFrame"..i.."NotPresentIcon"]:Hide()
			_G["PartyMemberFrame"..i.."NotPresentIcon"].Show = function() end
		end
		PlayerFrameGroupIndicator:SetAlpha(0)
		PlayerHitIndicator:SetText(nil) 
		PlayerHitIndicator.SetText = function() end
		PetHitIndicator:SetText(nil) 
		PetHitIndicator.SetText = function() end
	else
		CastingBarFrameBorder:SetVertexColor(.3,.3,.3)    
	end
	self:UnregisterEvent("PLAYER_ENTERING_WORLD")
       	CF:SetScript("OnEvent", nil)
end)
  

local CF = CreateFrame("Frame")
local _, instanceType = IsInInstance()
CF:RegisterEvent("ADDON_LOADED")
CF:RegisterEvent("PLAYER_ENTERING_WORLD")
CF:RegisterEvent("ARENA_PREP_OPPONENT_SPECIALIZATIONS")
       CF:SetScript("OnEvent", function(self, event, addon)
            	if addon == "Blizzard_ArenaUI" and not (IsAddOnLoaded("Shadowed Unit Frames")) then
		for i,v in pairs({
				ArenaEnemyFrame1Texture,
			ArenaEnemyFrame2Texture,
			ArenaEnemyFrame3Texture, 
			ArenaEnemyFrame4Texture,
			ArenaEnemyFrame5Texture,
			ArenaEnemyFrame1SpecBorder,
			ArenaEnemyFrame2SpecBorder,
			ArenaEnemyFrame3SpecBorder,
			ArenaEnemyFrame4SpecBorder,
			ArenaEnemyFrame5SpecBorder,
			ArenaEnemyFrame1PetFrameTexture,
			ArenaEnemyFrame2PetFrameTexture,
			ArenaEnemyFrame3PetFrameTexture,
			ArenaEnemyFrame4PetFrameTexture, 
			ArenaEnemyFrame5PetFrameTexture,
             		}) do
               		v:SetVertexColor(.3, .3, .3)
      		end 
	elseif event == "ARENA_PREP_OPPONENT_SPECIALIZATIONS" or (event == "PLAYER_ENTERING_WORLD" and instanceType == "arena") then
		for i,v in pairs({
			ArenaPrepFrame1Texture,
			ArenaPrepFrame2Texture,
			ArenaPrepFrame3Texture,
			ArenaPrepFrame4Texture,
			ArenaPrepFrame5Texture,
			ArenaPrepFrame1SpecBorder,
			ArenaPrepFrame2SpecBorder,
			ArenaPrepFrame3SpecBorder,
			ArenaPrepFrame4SpecBorder,
			ArenaPrepFrame5SpecBorder,
		}) do
               		v:SetVertexColor(.3, .3, .3)
      		end 		
	end 
end)

end
G:RegisterEvent("PLAYER_LOGIN",TestFunc)